#ifndef _IPMI_SENSOR_CMDS_H
#define _IPMI_SENSOR_CMDS_H

#ifdef __cplusplus
extern "C" {
#endif


#define IPMI_SNSR_GET_SENSOR_COUNT  0x00
#define IPMI_SNSR_GET_SDR_COUNT     0x01

/* #define IPMI_SDR_LUN_0_HAS_SENSORS  0x00 */
/* #define IPMI_SDR_LUN_1_HAS_SENSORS  0x01 */
/* #define IPMI_SDR_LUN_2_HAS_SENSORS  0x02 */
/* #define IPMI_SDR_LUN_3_HAS_SENSORS  0x03 */

#define SET_LOWER_NON_CRITICAL_THRESHOLD       1
#define SET_LOWER_CRITICAL_THRESHOLD           2 
#define SET_LOWER_NON_RECOVERABLE_THRESHOLD    4
#define SET_UPPER_NON_CRITICAL_THRESHOLD       8
#define SET_UPPER_CRITICAL_THRESHOLD           32
#define SET_UPPER_NON_RECOVERABLE_THRESHOLD    64


/* Intel - Not Implemented */
extern fiid_template_t tmpl_get_dev_sdr_info_rq;
extern fiid_template_t tmpl_get_dev_sdr_info_rs;
  
/* Intel - Not Implemented */
extern fiid_template_t tmpl_get_dev_sdr_rq;
extern fiid_template_t tmpl_get_dev_sdr_rs;

/* Intel - Not Implemented */
extern fiid_template_t tmpl_get_resrve_dev_sdr_repository_rq;
extern fiid_template_t tmpl_get_resrve_dev_sdr_repository_rs;

/* Intel - Not Implemented */
extern fiid_template_t tmpl_get_sensor_reading_factors_rq;
extern fiid_template_t tmpl_get_sensor_reading_factors_rs;

extern fiid_template_t tmpl_set_sensor_hysteresis_rq;
extern fiid_template_t tmpl_set_sensor_hysteresis_rs;

extern fiid_template_t tmpl_get_sensor_hysteresis_rq;
extern fiid_template_t tmpl_get_sensor_hysteresis_rs;

extern fiid_template_t tmpl_set_sensor_thresholds_rq;
extern fiid_template_t tmpl_set_sensor_thresholds_rs;

extern fiid_template_t tmpl_get_sensor_thresholds_rq;
extern fiid_template_t tmpl_get_sensor_thresholds_rs;

extern fiid_template_t tmpl_set_sensor_threshold_event_enable_rq;
extern fiid_template_t tmpl_set_sensor_threshold_event_enable_rs;
extern fiid_template_t tmpl_set_sensor_discrete_event_enable_rq;
extern fiid_template_t tmpl_set_sensor_discrete_event_enable_rs;

extern fiid_template_t tmpl_get_sensor_threshold_event_enable_rq;
extern fiid_template_t tmpl_get_sensor_threshold_event_enable_rs;
extern fiid_template_t tmpl_get_sensor_discrete_event_enable_rq;
extern fiid_template_t tmpl_get_sensor_discrete_event_enable_rs;

extern fiid_template_t tmpl_re_arm_sensor_threshold_events_rq;
extern fiid_template_t tmpl_re_arm_sensor_threshold_events_rs;
extern fiid_template_t tmpl_re_arm_sensor_discrete_events_rq;
extern fiid_template_t tmpl_re_arm_sensor_discrete_events_rs;

extern fiid_template_t tmpl_get_sensor_threshold_event_status_rq;
extern fiid_template_t tmpl_get_sensor_threshold_event_status_rs;
extern fiid_template_t tmpl_get_sensor_discrete_event_status_rq;
extern fiid_template_t tmpl_get_sensor_discrete_event_status_rs;

extern fiid_template_t tmpl_get_sensor_threshold_reading_rq;
extern fiid_template_t tmpl_get_sensor_threshold_reading_rs;
extern fiid_template_t tmpl_get_sensor_discrete_reading_rq;
extern fiid_template_t tmpl_get_sensor_discrete_reading_rs;

/* Intel - Not Implemented */
extern fiid_template_t tmpl_set_sensor_type_rq;
extern fiid_template_t tmpl_set_sensor_type_rs;

/* Intel - Not Implemented */
extern fiid_template_t tmpl_get_sensor_type_rq;
extern fiid_template_t tmpl_get_sensor_type_rs;


/* Intel - Not Implemented */
int8_t ipmi_kcs_get_dev_sdr_info (u_int16_t sms_io_base, 
				   u_int8_t sensor_sdr_info, 
				   fiid_obj_t obj_hdr_rs, 
				   fiid_obj_t obj_data_rs);
/* Intel - Not Implemented */
int8_t ipmi_kcs_get_dev_sdr (u_int16_t sms_io_base, 
			      u_int16_t reservation_id, 
			      u_int16_t record_id, 
			      u_int8_t record_offset, 
			      u_int8_t read_bytes, 
			      fiid_obj_t obj_hdr_rs, 
			      fiid_obj_t obj_data_rs, 
			      u_int8_t *record_data, 
			      u_int32_t record_length);
/* Intel - Not Implemented */
int8_t ipmi_kcs_get_resrve_dev_sdr_repository (u_int16_t sms_io_base, 
						fiid_obj_t obj_hdr_rs, 
						fiid_obj_t obj_data_rs);
/* Intel - Not Implemented */
int8_t ipmi_kcs_get_reading_factors (u_int16_t sms_io_base, 
				      u_int8_t sensor_number, 
				      u_int8_t reading_byte, 
				      fiid_obj_t obj_hdr_rs, 
				      fiid_obj_t obj_data_rs);

int8_t ipmi_kcs_set_hysteresis (u_int16_t sms_io_base, 
				 u_int8_t sensor_number, 
				 u_int8_t positive_threshold_hysteresis_value, 
				 u_int8_t negative_threshold_hysteresis_value, 
				 fiid_obj_t obj_hdr_rs, 
				 fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_hysteresis (u_int16_t sms_io_base, 
				 u_int8_t sensor_number, 
				 fiid_obj_t obj_hdr_rs, 
				 fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_set_thresholds (u_int16_t sms_io_base, 
				 u_int8_t sensor_number, 
				 u_int8_t threshold_flag, 
				 u_int8_t lower_non_critical_threshold, 
				 u_int8_t lower_critical_threshold, 
				 u_int8_t lower_non_recoverable_threshold, 
				 u_int8_t upper_non_critical_threshold, 
				 u_int8_t upper_critical_threshold, 
				 u_int8_t upper_non_recoverable_threshold, 
				 fiid_obj_t obj_hdr_rs, 
				 fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_thresholds (u_int16_t sms_io_base, 
				 u_int8_t sensor_number, 
				 fiid_obj_t obj_hdr_rs, 
				 fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_threshold_event_enable (u_int16_t sms_io_base, 
					     u_int8_t sensor_number, 
					     fiid_obj_t obj_hdr_rs, 
					     fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_discrete_event_enable (u_int16_t sms_io_base, 
					    u_int8_t sensor_number, 
					    fiid_obj_t obj_hdr_rs, 
					    fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_threshold_event_status (u_int16_t sms_io_base, 
					     u_int8_t sensor_number, 
					     fiid_obj_t obj_hdr_rs, 
					     fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_discrete_event_status (u_int16_t sms_io_base, 
					    u_int8_t sensor_number, 
					    fiid_obj_t obj_hdr_rs, 
					    fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_threshold_reading (u_int16_t sms_io_base, 
					u_int8_t sensor_number, 
					fiid_obj_t obj_hdr_rs, 
					fiid_obj_t obj_data_rs);
int8_t ipmi_kcs_get_discrete_reading (u_int16_t sms_io_base, 
				       u_int8_t sensor_number, 
				       fiid_obj_t obj_hdr_rs, 
				       fiid_obj_t obj_data_rs);

/* Intel - Not Implemented */
int8_t ipmi_kcs_set_type (u_int16_t sms_io_base, 
			   u_int8_t sensor_number, 
			   u_int8_t sensor_type, 
			   u_int8_t event_reading_type_code, 
			   fiid_obj_t obj_hdr_rs, 
			   fiid_obj_t obj_data_rs);
/* Intel - Not Implemented */
int8_t ipmi_kcs_get_type (u_int16_t sms_io_base, 
			   u_int8_t sensor_number, 
			   fiid_obj_t obj_hdr_rs, 
			   fiid_obj_t obj_data_rs);



#ifdef __cplusplus
}
#endif

#endif /* ipmi-sensor-cmds.h */
